#include "abashin.ru.notes.h"

//DEBUG
#include <iostream>

notes::notes () {

}

notes::notes (const string * notes_filename) {
  filename = *notes_filename;
  list_notes.clear();
  load_notes();
  create_list_of_categories();
}

notes::~notes () {
  list_notes.clear();
  filename.clear();
}

void notes::set_file(const string * notes_filename) {
  filename = *notes_filename;
}

void notes::load_notes() {
  struct note nt = {0};
  fstream file_with_notes;
  file_with_notes.open(filename, fstream::in);
  file_with_notes.seekg (0, file_with_notes.end);
  int length = file_with_notes.tellg();
  file_with_notes.seekg (0, file_with_notes.beg);
  char * buffer = new char [length];
  char field = 0;
  while (file_with_notes.getline (buffer, length)) {
    if (buffer[0] == '[')
    switch (buffer[1]) {
      case 't':
        if (buffer[2] == 'i') {
          field = 1;
          if (!nt.text.empty())
          list_notes.push_back(nt);
        }
        else if (buffer[2] == 'e') field = 2;
        break;
      case 's': field = 3; break;
      case 'c': field = 4; break;
      case 'd': field = 5; break;
      default: field = 0;
    }
    else
    switch (field) {
      case 1: nt.current_time = atoi(buffer); break;
      case 2: nt.text = buffer; break;
      case 3: nt.status = buffer; break;
      case 4: nt.category = buffer; break;
      case 5: nt.device = buffer; break;
      default:;
    }
  }
  if (!nt.text.empty())
  list_notes.push_back(nt);
  delete[] buffer;
  file_with_notes.close();
}

void notes::load_notes(const string * notes_filename) {
  filename = *notes_filename;
  list_notes.clear();
  load_notes();
}

void notes::save_notes() {
  fstream file_with_notes;
  file_with_notes.open(filename, fstream::out);
  for (list <note>::iterator it = list_notes.begin(); it != list_notes.end(); it++) {
    file_with_notes << "[time]" << endl;
    file_with_notes << it->current_time << endl;
    file_with_notes << "[text]" << endl;
    file_with_notes << it->text << endl;
    file_with_notes << "[status]" << endl;
    file_with_notes << it->status << endl;
    file_with_notes << "[category]" << endl;
    file_with_notes << it->category << endl;
    file_with_notes << "[device]" << endl;
    file_with_notes << it->device << endl;
  }
  file_with_notes.close();
}

void notes::save_notes(const string * notes_filename) {
  filename = *notes_filename;
  save_notes();
}

void notes::create_note(struct note * note_add) {
  if (note_add->text.empty()) return;
  if (note_add->category.empty())
      note_add->category = CATEGORY_NONE;
  if (note_add->category.compare(CATEGORY_NONE) != 0) {
    list <string>::iterator itc = find(list_categories.begin(), list_categories.end(),
                                     note_add->category);
    if (itc != list_categories.end()) list_categories.push_back(note_add->category);
  }
  if (note_add->text.front() == '[') note_add->text.insert(0, " ");
  list_notes.push_back(*note_add);
}

void notes::create_category(const string * category) {
  list_categories.push_back(*category);
}

void notes::create_list_of_categories() {
  list_categories.clear();
  char flag = 0;
  for (list <note>::iterator it = list_notes.begin(); it != list_notes.end(); it++) {
    for (list <string>::iterator itc = list_categories.begin();
         itc != list_categories.end(); itc++)
         if (it->category.compare(*itc) == 0) {
           flag = 1;
           break;
         }
    if (!flag) list_categories.push_back(it->category);
    else flag = 0;
  }
  list_categories.push_back(CATEGORY_NONE);
}

string * notes::show_category(string * category) {
  if (show_category_iterator == list_categories.end()) {
    show_category_iterator = list_categories.begin();
    return NULL;
  }
  *category = *show_category_iterator;
  show_category_iterator++;
  return category;
}

void notes::show_category_reset() {
  show_category_iterator = list_categories.begin();
}

void notes::change_the_name_of_the_category(const string * old_name, const string * new_name) {
  list <string>::iterator itc = find(list_categories.begin(), list_categories.end(), *old_name);
  if (itc != list_categories.end()) list_categories.erase(itc);
  itc = find(list_categories.begin(), list_categories.end(), *new_name);
  if (itc == list_categories.end()) list_categories.push_back(*new_name);
  for (list <note>::iterator it = list_notes.begin(); it != list_notes.end(); it++) {
    if (it->category.compare(*old_name) == 0) {
      it->category = *new_name;
    }
  }
}

void notes::merge_category(const string * basic_name, const string * join_name) {
  change_the_name_of_the_category(join_name, basic_name);
}

void notes::delete_category(string * category_name) {
  for (list <string>::iterator itc = list_categories.begin();
       itc != list_categories.end(); itc++)
       if (itc->compare(*category_name) == 0) {
         list_categories.erase(itc);
         break;
       }
  for (list <note>::iterator it = list_notes.begin(); it != list_notes.end(); it++) {
    if (it->category.compare(*category_name) == 0) {
      it->category = CATEGORY_NONE;
    }
  }
}

void notes::delete_note(const struct note * note_del) {
  for (list <note>::iterator it = list_notes.begin(); it != list_notes.end(); it++) {
    if (it->text.compare(note_del->text) == 0) {
      list_notes.erase(it);
      it = list_notes.begin();
    }
  }
}

void notes::delete_local_notes() {
  list_notes.clear();
  fstream file_with_notes;
  file_with_notes.open(filename, fstream::out);
  file_with_notes.close();
}

void notes::delete_notes_category(string * category_name) {
  for (list <note>::iterator it = list_notes.begin(); it != list_notes.end(); it++) {
    if (it->category.compare(*category_name) == 0) {
      list_notes.erase(it);
      it = list_notes.begin();
    }
  }
  delete_category(category_name);
}

void notes::delete_all_notes() {
  list_notes.clear();
  fstream file_with_notes;
  file_with_notes.open(filename, fstream::out);
  file_with_notes.close();
}

struct note * notes::show_notes(struct note * nt) {
  if (show_list_notes_iterator == list_notes.end()) {
    show_list_notes_iterator = list_notes.begin();
    return NULL;
  }
  nt->current_time = show_list_notes_iterator->current_time;
  nt->text = show_list_notes_iterator->text;
  nt->status = show_list_notes_iterator->status;
  nt->category = show_list_notes_iterator->category;
  nt->device = show_list_notes_iterator->device;
  show_list_notes_iterator++;
  return nt;
}

void notes::show_notes_reset() {
  show_list_notes_iterator = list_notes.begin();
}
