#ifndef ABASHIN_RU_NOTES_H
#define ABASHIN_RU_NOTES_H

#include <ctime>
#include <fstream>
#include <algorithm>
#include <string>
#include <list>

#define CATEGORY_NONE "none"

using namespace std;

struct note {
  time_t current_time;
  string text;
  string status;
  string category;
  string device;
};

class notes {
public:
  notes ();
  notes (const string * notes_filename);
  ~notes ();
  void set_file(const string * notes_filename);
  void load_notes(void );
  void load_notes(const string * notes_filename);
  void save_notes();
  void save_notes(const string * notes_filename);
  void create_note(struct note * note_add);
  void create_category(const string * category);
  void create_list_of_categories();
  void change_the_name_of_the_category(const string * old_name, const string * new_name);
  void merge_category(const string * basic_name, const string * join_name);
  void delete_category(string * category_name);
  void delete_note(const struct note * note_del);
  void delete_local_notes();
  void delete_notes_category(string * category_name);
  void delete_all_notes();
  struct note * show_notes(struct note * nt);
  void show_notes_reset();
  string * show_category(string * category);
  void show_category_reset();

private:
  string filename;
  list <note> list_notes;
  list <string> list_categories;
  list <string>::iterator show_category_iterator;
  list <note>::iterator show_list_notes_iterator;
};

#endif

/*File format:
[time]
111111
[text]
Text
[status]
status
[category]
category
[device]
local/device
*/
