#include "abashin.ru.notes.h"
#include <iostream>
#include <string>
#include <cstring>

using namespace std;

void change_category_name (char * filename, char * old_name, char * new_name) {
  string fn = filename;
  notes nts (&fn);
  string o_n = old_name;
  string n_n = new_name;
  nts.change_the_name_of_the_category(&o_n, &n_n);
  nts.save_notes(&fn);
}

void add_note (char * filename, char * text, char * category) {
  string fn = filename;
  notes nts (&fn);
  struct note note_add = {0};
  note_add.current_time = time(NULL);
  note_add.text = text;
  note_add.status = "no";
  note_add.category = category;
  note_add.device = "local";
  nts.create_note(&note_add);
  nts.save_notes(&fn);
}

void find_notes (char * filename, char * text_shablon) {
  string fn = filename;
  notes nts (&fn);
  struct note nt = {0};
  nts.show_notes_reset();
  struct tm * timeinfo = localtime(&nt.current_time);
  while(nts.show_notes(&nt) != NULL) {
    if ((nt.text.find(text_shablon) != string::npos) ||
        (nt.status.find(text_shablon) != string::npos) ||
        (nt.category.find(text_shablon) != string::npos) ||
        (nt.device.find(text_shablon) != string::npos)) {
      timeinfo = localtime(&nt.current_time);
      cout << timeinfo->tm_year + 1900 << "." << timeinfo->tm_mon+1 << "." <<
      timeinfo->tm_mday << " " << timeinfo->tm_hour << ":" <<
      timeinfo->tm_min << ":" << timeinfo->tm_sec << " " <<
      nt.text << " " << "Category: " <<
      nt.category << " Device: " << nt.device << endl;
    }
  }
  nts.save_notes(&fn);
}

void delete_notes_category (char * filename, char * category) {
  string fn = filename;
  notes nts (&fn);
  string category_name = category;
  nts.delete_notes_category(&category_name);
  nts.save_notes(&fn);
}

void delete_category (char * filename, char * category) {
  string fn = filename;
  notes nts (&fn);
  string category_name = category;
  nts.delete_category(&category_name);
  nts.save_notes(&fn);
}

void add_category (char * filename, char * category) {
  string fn = filename;
  notes nts (&fn);
  string categ = category;
  nts.create_category(&categ);
  nts.save_notes(&fn);
}

void delete_note_n (char * filename, char * number) {
  string fn = filename;
  notes nts (&fn);
  struct note nt = {0};
  nts.show_notes_reset();
  int count = 0;
  while(nts.show_notes(&nt) != NULL) {
    if ((atoi(number) - 1) == count) nts.delete_note(&nt);
    count++;
  }
  nts.save_notes(&fn);
}

void delete_note_t (char * filename, char * text_shablon) {
  string fn = filename;
  notes nts (&fn);
  struct note nt = {0};
  nts.show_notes_reset();
  while(nts.show_notes(&nt) != NULL) {
    if (nt.text.find(text_shablon) != string::npos) nts.delete_note(&nt);
  }
  nts.save_notes(&fn);
}

void show_all_categories (char * filename) {
  string fn = filename;
  notes nts (&fn);
  string category;
  nts.show_category_reset();
  while(nts.show_category(&category) != NULL)
    cout << category << endl;
}

void delete_all_local_notes (char * filename) {
  string fn = filename;
  notes nts (&fn);
  nts.delete_local_notes();
  nts.save_notes(&fn);
}

void show_all_notes (char * filename) {
  string fn = filename;
  notes nts (&fn);
  struct note nt = {0};
  nts.show_notes_reset();
  struct tm * timeinfo = localtime(&nt.current_time);
  while(nts.show_notes(&nt) != NULL) {
    timeinfo = localtime(&nt.current_time);
    cout << timeinfo->tm_year + 1900 << "." << timeinfo->tm_mon+1 << "." <<
    timeinfo->tm_mday << " " << timeinfo->tm_hour << ":" <<
    timeinfo->tm_min << ":" << timeinfo->tm_sec << " " <<
    nt.text << " " << "Category: " <<
    nt.category << " Device: " << nt.device << endl;
  }
}

void show_help () {
  cout << endl << "abashin.ru.notes version 0.0.2 alpha" << endl << endl;
  cout << "Show all notes: ./abashin.ru.notes -sn \"path/filename\"" << endl;
  cout << "Add note: ./abashin.ru.notes -cn \"text\" \"category\" \"path/filename\"" << endl;
  cout << "Delete note: ./abashin.ru.notes -dnt \"text shablon\" \"path/filename\"" << endl;
  cout << "Delete note: ./abashin.ru.notes -dnn \"number\" \"path/filename\"" << endl;
  cout << "Delete all local notes: ./abashin.ru.notes -dln \"path/filename\"" << endl;
  cout << endl;
  cout << "Show categories: ./abashin.ru.notes -sc \"path/filename\"" << endl;
  cout << "Delete category: ./abashin.ru.notes -dc \"my category\" \"path/filename\"" << endl;
  cout << "Change category name: ./abashin.ru.notes -cnc \"old name\" \"new name\" \"path/filename\"" << endl;
  cout << "Delete all note category: ./abashin.ru.notes -dnc \"category\" \"path/filename\"" << endl << endl;
  cout << "Find the pattern: ./abashin.ru.notes -fn \"text shablon\" \"path/filename\"" << endl << endl;
}

int main (int argc, char * argv[]) {
  switch (argc) {
    case 3: {
      if (strcmp(argv[1],"-sn") == 0) { show_all_notes (argv[2]); break;}
      if (strcmp(argv[1],"-dln") == 0) { delete_all_local_notes (argv[2]); break;}
      if (strcmp(argv[1],"-sc") == 0) show_all_categories (argv[2]);
      break;
    }
    case 4: {
      if (strcmp(argv[1],"-dnt") == 0) { delete_note_t (argv[3], argv[2]); break;}
      if (strcmp(argv[1],"-dnn") == 0) { delete_note_n (argv[3], argv[2]); break;}
      if (strcmp(argv[1],"-cc") == 0) { add_category (argv[3], argv[2]); break;}
      if (strcmp(argv[1],"-dc") == 0) { delete_category (argv[3], argv[2]); break;}
      if (strcmp(argv[1],"-dnc") == 0) { delete_notes_category (argv[3], argv[2]); break;}
      if (strcmp(argv[1],"-fn") == 0) find_notes (argv[3], argv[2]);
      break;
    }
    case 5: {
      if (strcmp(argv[1],"-cn") == 0) { add_note (argv[4], argv[2], argv[3]); break;}
      if (strcmp(argv[1],"-cnc") == 0) change_category_name (argv[4], argv[2], argv[3]);
      break;
    }
    default: show_help();
  }
  return 0;
}
