#include "abashin.ru.tasks.h"

//DEBUG
#include <iostream>

tasks::tasks () {

}

tasks::tasks (const string * tasks_filename) {
  filename = *tasks_filename;
  list_tasks.clear();
  load_tasks();
  create_list_of_skill();
}

tasks::tasks (const string * tasks_filename, const string * task_record_filename) {
  filename = *tasks_filename;
  file_task_record = *task_record_filename;
  list_tasks.clear();
  load_tasks();
  load_tasks_record();
  create_list_of_skill();
}

tasks::~tasks () {
  list_tasks.clear();
  filename.clear();
}

void tasks::set_file(const string * tasks_filename, const string * task_record_filename) {
  filename = *tasks_filename;
  file_task_record = *task_record_filename;
}

void tasks::load_tasks() {
  struct task st = {0};
  fstream file_with_tasks;
  file_with_tasks.open(filename, fstream::in);
  if ((file_with_tasks.rdstate() & ifstream::failbit) != 0) return;
  file_with_tasks.seekg (0, file_with_tasks.end);
  int length = file_with_tasks.tellg();
  file_with_tasks.seekg (0, file_with_tasks.beg);
  char * buffer = new char [length];
  char field = 0;
  while (file_with_tasks.getline (buffer, length)) {
    if (strcmp(buffer, CREATE_TIME) == 0) {
      if (!st.label.empty())
      list_tasks.push_back(st);
      field = 1;
      continue;
    }
    if (strcmp(buffer, ID) == 0) {
      field = 2;
      continue;
    }
    if (strcmp(buffer, LABEL) == 0) {
      field = 3;
      continue;
    }
    if (strcmp(buffer, START_TIME) == 0) {
      field = 4;
      continue;
    }
    if (strcmp(buffer, STOP_TIME) == 0) {
      field = 5;
      continue;
    }
    if (strcmp(buffer, PRIORITY) == 0) {
      field = 6;
      continue;
    }
    if (strcmp(buffer, SIGNAL) == 0) {
      field = 7;
      continue;
    }
    if (strcmp(buffer, STATUS) == 0) {
      field = 8;
      continue;
    }
    if (strcmp(buffer, TEXT) == 0) {
      field = 9;
      continue;
    }
    if (strcmp(buffer, SKILL) == 0) {
      field = 10;
      continue;
    }
    switch (field) {
      case 1: st.create_time = atoi(buffer); break;
      case 2: st.id = buffer; break;
      case 3: st.label = buffer; break;
      case 4: st.start_time = atoi(buffer); break;
      case 5: st.stop_time = atoi(buffer); break;
      case 6: st.priority = atoi(buffer); break;
      case 7: st.signal = buffer; break;
      case 8: st.status = buffer; break;
      case 9: st.text = buffer; break;
      case 10: st.skill = buffer; break;
      default:;
    }
  }
  if (!st.label.empty())
  list_tasks.push_back(st);
  delete[] buffer;
  file_with_tasks.close();
}

void tasks::load_tasks(const string * tasks_filename) {
  filename = *tasks_filename;
  list_tasks.clear();
  load_tasks();
}

void tasks::save_tasks() {
  fstream file_with_tasks;
  file_with_tasks.open(filename, fstream::out);
  if ((file_with_tasks.rdstate() & ifstream::failbit) != 0) return;
  for (list <task>::iterator it = list_tasks.begin(); it != list_tasks.end(); it++) {
    file_with_tasks << CREATE_TIME << endl;
    file_with_tasks << it->create_time << endl;
    file_with_tasks << ID << endl;
    file_with_tasks << it->id << endl;
    file_with_tasks << LABEL << endl;
    file_with_tasks << it->label << endl;
    file_with_tasks << START_TIME << endl;
    file_with_tasks << it->start_time << endl;
    file_with_tasks << STOP_TIME << endl;
    file_with_tasks << it->stop_time << endl;
    file_with_tasks << PRIORITY << endl;
    file_with_tasks << it->priority << endl;
    file_with_tasks << SIGNAL << endl;
    file_with_tasks << it->signal << endl;
    file_with_tasks << STATUS << endl;
    file_with_tasks << it->status << endl;
    file_with_tasks << TEXT << endl;
    file_with_tasks << it->text << endl;
    file_with_tasks << SKILL << endl;
    file_with_tasks << it->skill << endl;
  }
  file_with_tasks.close();
}

void tasks::save_tasks(const string * tasks_filename) {
  filename = *tasks_filename;
  save_tasks();
}

void tasks::create_task(struct task * task_add) {
  if (task_add->label.empty()) return;
  if (task_add->skill.empty())
      task_add->skill = TEXT_NONE;
  if (task_add->skill.compare(TEXT_NONE) != 0) {
    list <string>::iterator itc = find(list_skills.begin(), list_skills.end(),
                                     task_add->skill);
    if (itc != list_skills.end()) list_skills.push_back(task_add->skill);
  }
  int i = 0;
  int max_int = 2;
  int razr = (sizeof(int) * 8) - 2;
  for (i = 0; i < razr; i++) max_int *= 2;
  max_int++;
  max_int *= -1;
  char flag = 0;
  string id_value;
  for (i = 0; i < max_int; i++) {
    id_value.clear();
    id_value = to_string(i);
    for (list <task>::iterator it = list_tasks.begin(); it != list_tasks.end(); it++) {
      if (it->id == id_value) {
        flag = 1;
        break;
      }
    }
    if (flag == 0) {
      task_add->id = id_value;
      break;
    }
    flag = 0;
  }
  list_tasks.push_back(*task_add);
}

void tasks::create_skill(const string * skill) {
  list_skills.push_back(*skill);
}

void tasks::create_list_of_skill() {
  list_skills.clear();
  char flag = 0;
  for (list <task>::iterator it = list_tasks.begin(); it != list_tasks.end(); it++) {
    for (list <string>::iterator itc = list_skills.begin();
         itc != list_skills.end(); itc++)
         if (it->skill.compare(*itc) == 0) {
           flag = 1;
           break;
         }
    if (!flag) list_skills.push_back(it->skill);
    else flag = 0;
  }
  list_skills.push_back(TEXT_NONE);
}

string * tasks::show_skill(string * skill) {
  if (show_skills_iterator == list_skills.end()) {
    show_skills_iterator = list_skills.begin();
    return NULL;
  }
  *skill = *show_skills_iterator;
  show_skills_iterator++;
  return skill;
}

void tasks::show_skill_reset() {
  show_skills_iterator = list_skills.begin();
}

void tasks::change_the_name_of_the_skill(const string * old_name, const string * new_name) {
  list <string>::iterator itc = find(list_skills.begin(), list_skills.end(), *old_name);
  if (itc != list_skills.end()) list_skills.erase(itc);
  itc = find(list_skills.begin(), list_skills.end(), *new_name);
  if (itc == list_skills.end()) list_skills.push_back(*new_name);
  for (list <task>::iterator it = list_tasks.begin(); it != list_tasks.end(); it++) {
    if (it->skill.compare(*old_name) == 0) {
      it->skill = *new_name;
    }
  }
}

void tasks::merge_skill(const string * basic_name, const string * join_name) {
  change_the_name_of_the_skill(join_name, basic_name);
}

void tasks::delete_skill(string * skill_name) {
  for (list <string>::iterator itc = list_skills.begin();
       itc != list_skills.end(); itc++)
       if (itc->compare(*skill_name) == 0) {
         list_skills.erase(itc);
         break;
       }
  for (list <task>::iterator it = list_tasks.begin(); it != list_tasks.end(); it++) {
    if (it->skill.compare(*skill_name) == 0) {
      it->skill = TEXT_NONE;
    }
  }
}

void tasks::delete_task(const struct task * task_del) {
  for (list <task>::iterator it = list_tasks.begin(); it != list_tasks.end(); it++) {
    if ((it->text.compare(task_del->text) == 0) ||
        (it->label.compare(task_del->label) == 0)) {
      list_tasks.erase(it);
      it = list_tasks.begin();
    }
  }
}

void tasks::delete_local_tasks() {
  list_tasks.clear();
  fstream file_with_tasks;
  file_with_tasks.open(filename, fstream::out);
  if ((file_with_tasks.rdstate() & ifstream::failbit) != 0) return;
  file_with_tasks.close();
}

void tasks::delete_tasks_skill(string * skill_name) {
  for (list <task>::iterator it = list_tasks.begin(); it != list_tasks.end(); it++) {
    if (it->skill.compare(*skill_name) == 0) {
      list_tasks.erase(it);
      it = list_tasks.begin();
    }
  }
  delete_skill(skill_name);
}

void tasks::delete_all_tasks() {
  list_tasks.clear();
  fstream file_with_tasks;
  file_with_tasks.open(filename, fstream::out);
  if ((file_with_tasks.rdstate() & ifstream::failbit) != 0) return;
  file_with_tasks.close();
}

struct task * tasks::show_tasks(struct task * st) {
  if (show_list_tasks_iterator == list_tasks.end()) {
    show_list_tasks_iterator = list_tasks.begin();
    return NULL;
  }
  st->create_time = show_list_tasks_iterator->create_time;
  st->id = show_list_tasks_iterator->id;
  st->label = show_list_tasks_iterator->label;
  st->start_time = show_list_tasks_iterator->start_time;
  st->stop_time = show_list_tasks_iterator->stop_time;
  st->priority = show_list_tasks_iterator->priority;
  st->signal = show_list_tasks_iterator->signal;
  st->status = show_list_tasks_iterator->status;
  st->text = show_list_tasks_iterator->text;
  st->skill = show_list_tasks_iterator->skill;
  show_list_tasks_iterator++;
  return st;
}

void tasks::show_tasks_reset() {
  show_list_tasks_iterator = list_tasks.begin();
}

char tasks::change_the_task (int number, struct task * chtask) {
  if (!chtask->id.empty())
    for (list <task>::iterator it = list_tasks.begin(); it != list_tasks.end(); it++)
      if (it->id.compare(chtask->id) == 0) return 1;
  list <task>::iterator it = list_tasks.begin();
  int count = 0;
  for (count = 0; count < number; count++) {
    it++;
    if (it == list_tasks.end()) return 1;
  }
  it->create_time = chtask->create_time;
  it->label = chtask->label;
  it->start_time = chtask->start_time;
  it->stop_time = chtask->stop_time;
  it->priority = chtask->priority;
  it->signal = chtask->signal;
  it->status = chtask->status;
  it->text = chtask->text;
  it->skill = chtask->skill;
  return 0;
}

void tasks::control_id (void) {
  int i = 0;
  int max_int = 2;
  int razr = (sizeof(int) * 8) - 2;
  for (i = 0; i < razr; i++) max_int *= 2;
  max_int++;
  max_int *= -1;
  // ...
}

void tasks::load_tasks_record(void) {
  struct task_record tr = {0};
  fstream file_with_tasks_record;
  file_with_tasks_record.open(file_task_record, fstream::in);
  if ((file_with_tasks_record.rdstate() & ifstream::failbit) != 0) return;
  while (1) {
    file_with_tasks_record >> tr.create_time;
    if (!file_with_tasks_record.good()) break;
    file_with_tasks_record >> tr.id;
    if (!file_with_tasks_record.good()) break;
    file_with_tasks_record >> tr.status;
    if (!file_with_tasks_record.good()) break;
    list_task_records.push_back(tr);
  }
  file_with_tasks_record.close();
}

void tasks::load_tasks_record(const string * tasks_record_filename) {
  filename = *tasks_record_filename;
  list_task_records.clear();
  load_tasks_record();
}

void tasks::save_tasks_record(void) {
  fstream file_with_tasks_record;
  file_with_tasks_record.open(file_task_record, fstream::out);
  for (list <task_record>::iterator it = list_task_records.begin();
                               it != list_task_records.end(); it++) {
    file_with_tasks_record << it->create_time << " ";
    file_with_tasks_record << it->id << " ";
    file_with_tasks_record << it->status << endl;
  }
  file_with_tasks_record.close();
}

void tasks::save_tasks_record(const string * tasks_record_filename) {
  filename = *tasks_record_filename;
  save_tasks_record();
}

void tasks::activate_task (string * task_id) {
  fstream file_with_tasks_record;
  file_with_tasks_record.open(file_task_record, fstream::app);
  file_with_tasks_record << time(NULL) << " ";
  file_with_tasks_record << *task_id << " ";
  file_with_tasks_record << TASK_STATUS_ON << endl;
  file_with_tasks_record.close();
}

void tasks::deactivate_task (void) {
  fstream file_with_tasks_record;
  file_with_tasks_record.open(file_task_record, fstream::app);
  file_with_tasks_record << time(NULL) << " ";
  file_with_tasks_record << 0 << " ";
  file_with_tasks_record << TASK_STATUS_OFF << endl;
  file_with_tasks_record.close();
}

string * tasks::show_active_task (string * active_task_id) {
  active_task_id->clear();
  for (list <task_record>::reverse_iterator it = list_task_records.rbegin();
                                        it != list_task_records.rend(); ++it) {
    if (it->status.compare(TASK_STATUS_ON) == 0) {
      *active_task_id = it->id;
      return active_task_id;
    }
  }
  return active_task_id;
}
