#include "abashin.ru.tasks.h"
#include <iostream>
#include <string>
#include <cstring>

using namespace std;

char is_digit (char simbol) {
  switch (simbol) {
    case '0': return 0;
    case '1': return 1;
    case '2': return 2;
    case '3': return 3;
    case '4': return 4;
    case '5': return 5;
    case '6': return 6;
    case '7': return 7;
    case '8': return 8;
    case '9': return 9;
    default: return -1;
  }
}

time_t string_to_time_t (const string * date_time) {
  //From 2017.03.31 12:23 to time_t
  time_t tt = time(NULL);
  struct tm * timeinfo = localtime(&tt);
  string dts = *date_time;
  int dtslen = date_time->length();
  char buffer[5] = {0};
  int i = 0;
  int j = 0;
  for (i = 0; i < dtslen; i++) {
    if (is_digit(dts[i]) < 0) {
      //dts.copy(buffer,0,i); //Not work!!!
      buffer[i] = '\0';
      timeinfo->tm_year = atoi(buffer) - 1900;
      break;
    }
    buffer[i] = dts[i];
  }
  memset(buffer,0,5);
  for (j = 0, i++; i < dtslen; i++, j++) {
    if (is_digit(dts[i]) < 0) {
      buffer[j] = '\0';
      timeinfo->tm_mon = atoi(buffer) - 1;
      break;
    }
    buffer[j] = dts[i];
  }
  if (i >= dtslen) {
    timeinfo->tm_mon = atoi(buffer);
    if (timeinfo->tm_mon < 0) timeinfo->tm_mon = 0;
  }
  memset(buffer,0,5);
  for (j = 0, i++; i < dtslen; i++, j++) {
    if (is_digit(dts[i]) < 0) {
      buffer[j] = '\0';
      timeinfo->tm_mday = atoi(buffer);
      break;
    }
    buffer[j] = dts[i];
  }
  if (i >= dtslen) timeinfo->tm_mday = atoi(buffer);
  memset(buffer,0,5);
  for (j = 0, i++; i < dtslen; i++, j++) {
    if (is_digit(dts[i]) < 0) {
      buffer[j] = '\0';
      timeinfo->tm_hour = atoi(buffer);
      break;
    }
    buffer[j] = dts[i];
  }
  if (i >= dtslen) timeinfo->tm_hour = atoi(buffer);
  memset(buffer,0,5);
  for (j = 0, i++; i < dtslen; i++, j++) {
    if (is_digit(dts[i]) < 0) {
      buffer[j] = '\0';
      timeinfo->tm_min = atoi(buffer);
      break;
    }
    buffer[j] = dts[i];
  }
  if (i >= dtslen) timeinfo->tm_min = atoi(buffer);
  memset(buffer,0,5);
  for (j = 0, i++; i < dtslen; i++, j++) {
    if (is_digit(dts[i]) < 0) {
      buffer[j] = '\0';
      timeinfo->tm_sec = atoi(buffer);
      break;
    }
    buffer[j] = dts[i];
  }
  if (i >= dtslen) timeinfo->tm_sec = atoi(buffer);
  tt = mktime (timeinfo);
  return tt;
}

void priority_word_recognizer (string priority_type) {
  int prt[10] = {0};
  prt[9] = priority_type.length();
  for (int i = 0; i < (signed int)priority_type.length() - 1; i++) {
    switch (priority_type[i]) {
      case 'h': prt[0]++; break;
      case 'i': prt[1]++; break;
      case 'g': prt[2]++; break;
      case 'm': prt[3]++; break;
      case 'd': prt[4]++; break;
      case 'l': prt[5]++; break;
      case 'e': prt[6]++; break;
      case 'o': prt[7]++; break;
      case 'w': prt[8]++; break;
      default: ;
    }
  }
/*
h i g m d l e o w length
2 1 1 0 0 0 0 0 0 4  high
0 1 0 1 2 1 1 0 0 6  middle
0 0 0 0 0 1 0 1 1 3  low
*/
  char distance_high = 0;
  if (prt[0] == 2) distance_high++;
  if (prt[1] == 1) distance_high++;
  if (prt[2] == 1) distance_high++;
  if (prt[3] == 0) distance_high++;
  if (prt[4] == 0) distance_high++;
  if (prt[5] == 0) distance_high++;
  if (prt[6] == 0) distance_high++;
  if (prt[7] == 0) distance_high++;
  if (prt[8] == 0) distance_high++;
  if (prt[9] == 4) distance_high++;
  char distance_middle = 0;
  if (prt[0] == 0) distance_middle++;
  if (prt[1] == 1) distance_middle++;
  if (prt[2] == 0) distance_middle++;
  if (prt[3] == 1) distance_middle++;
  if (prt[4] == 2) distance_middle++;
  if (prt[5] == 1) distance_middle++;
  if (prt[6] == 1) distance_middle++;
  if (prt[7] == 0) distance_middle++;
  if (prt[8] == 0) distance_middle++;
  if (prt[9] == 6) distance_middle++;
  char distance_low = 0;
  if (prt[0] == 0) distance_low++;
  if (prt[1] == 0) distance_low++;
  if (prt[2] == 0) distance_low++;
  if (prt[3] == 0) distance_low++;
  if (prt[4] == 0) distance_low++;
  if (prt[5] == 1) distance_low++;
  if (prt[6] == 0) distance_low++;
  if (prt[7] == 1) distance_low++;
  if (prt[8] == 1) distance_low++;
  if (prt[9] == 3) distance_low++;
  if (distance_high > distance_middle) {
    if (distance_high > distance_low) {
      priority_type = "high";
    }
    else priority_type = "low";
  }
  else {
    if (distance_middle > distance_low) {
      priority_type = "middle";
    }
    else priority_type = "low";
  }
}

void change_skill_name (char * filename, char * old_name, char * new_name) {
  string fn = filename;
  tasks tsk (&fn);
  string o_n = old_name;
  string n_n = new_name;
  tsk.change_the_name_of_the_skill(&o_n, &n_n);
  tsk.save_tasks(&fn);
}

void add_task (char * filename, char * start_time, char * stop_time,
               char * priority, char * label, char * text, char * skill,
               char * status) {
  string fn = filename;
  tasks tsk (&fn);
  struct task task_add = {0};
  task_add.create_time = time(NULL);
  task_add.id.clear();
  string buffer;
  buffer = start_time;
  task_add.start_time = string_to_time_t (&buffer);
  buffer = stop_time;
  task_add.stop_time = string_to_time_t (&buffer);
  task_add.label = label;
  task_add.text = text;
  buffer.clear();
  buffer = priority;
  priority_word_recognizer (buffer);
  if (buffer.compare("high") == 0) task_add.priority = HIGH;
  else if (buffer.compare("middle") == 0) task_add.priority = MIDDLE;
  else task_add.priority = LOW;
  task_add.signal.clear();
  task_add.status = status;
  task_add.skill = skill;
  tsk.create_task(&task_add);
  tsk.save_tasks(&fn);
}

void find_tasks (char * filename, char * text_shablon) {
  string fn = filename;
  tasks tsk (&fn);
  struct task ts = {0};
  tsk.show_tasks_reset();
  struct tm * timeinfo = localtime(&ts.create_time);
  while(tsk.show_tasks(&ts) != NULL) {
    if ((ts.label.find(text_shablon) != string::npos) ||
        (ts.status.find(text_shablon) != string::npos) ||
        (ts.text.find(text_shablon) != string::npos) ||
        (ts.skill.find(text_shablon) != string::npos)) {
      timeinfo = localtime(&ts.start_time);
      cout << "From: " << timeinfo->tm_year + 1900 << "." <<
      timeinfo->tm_mon+1 << "." << timeinfo->tm_mday << " " <<
      timeinfo->tm_hour << ":" << timeinfo->tm_min << ":" <<
      timeinfo->tm_sec;
      timeinfo = localtime(&ts.stop_time);
      cout << " to: " << timeinfo->tm_year + 1900 << "." <<
      timeinfo->tm_mon+1 << "." << timeinfo->tm_mday << " " <<
      timeinfo->tm_hour << ":" << timeinfo->tm_min << ":" <<
      timeinfo->tm_sec << " ";
      switch (ts.priority) {
        case HIGH: cout << "high"; break;
        case MIDDLE: cout << "middle"; break;
        default: cout << "low"; break;
      }
      cout << " " << ts.label << " " << ts.status << " " << ts.text << " " << ts.skill << endl;
    }
  }
}

void delete_tasks_skill (char * filename, char * skill) {
  string fn = filename;
  tasks tsk (&fn);
  string skill_name = skill;
  tsk.delete_tasks_skill(&skill_name);
  tsk.save_tasks(&fn);
}

void delete_skill (char * filename, char * skill) {
  string fn = filename;
  tasks tsk (&fn);
  string skill_name = skill;
  tsk.delete_skill(&skill_name);
  tsk.save_tasks(&fn);
}

void add_skill (char * filename, char * skill) {
  string fn = filename;
  tasks tsk (&fn);
  string sk = skill;
  tsk.create_skill(&sk);
  tsk.save_tasks(&fn);
}

void delete_task_n (char * filename, char * number) {
  string fn = filename;
  tasks tsk (&fn);
  struct task ts = {0};
  tsk.show_tasks_reset();
  int count = 0;
  while(tsk.show_tasks(&ts) != NULL) {
    if ((atoi(number) - 1) == count) tsk.delete_task(&ts);
    count++;
  }
  tsk.save_tasks(&fn);
}

void delete_task_t (char * filename, char * text_shablon) {
  string fn = filename;
  tasks tsk (&fn);
  struct task ts = {0};
  tsk.show_tasks_reset();
  while(tsk.show_tasks(&ts) != NULL) {
    if (ts.label.find(text_shablon) != string::npos ||
        ts.status.find(text_shablon) != string::npos ||
        ts.text.find(text_shablon) != string::npos ||
        ts.skill.find(text_shablon) != string::npos) tsk.delete_task(&ts);
  }
  tsk.save_tasks(&fn);
}

void show_all_skills (char * filename) {
  string fn = filename;
  tasks tsk (&fn);
  string skill_name;
  tsk.show_skill_reset();
  while(tsk.show_skill(&skill_name) != NULL)
    cout << skill_name << endl;
}

void delete_all_local_tasks (char * filename) {
  string fn = filename;
  tasks tsk (&fn);
  tsk.delete_local_tasks();
  tsk.save_tasks(&fn);
}

void show_all_tasks (char * filename) {
  string fn = filename;
  tasks tsk (&fn);
  struct task tk = {0};
  tsk.show_tasks_reset();
  struct tm * timeinfo = localtime(&tk.create_time);
  while(tsk.show_tasks(&tk) != NULL) {
    timeinfo = localtime(&tk.start_time);
    cout << "From: " << timeinfo->tm_year + 1900 << "." <<
    timeinfo->tm_mon+1 << "." << timeinfo->tm_mday << " " <<
    timeinfo->tm_hour << ":" << timeinfo->tm_min << ":" <<
    timeinfo->tm_sec;
    timeinfo = localtime(&tk.stop_time);
    cout << " to: " << timeinfo->tm_year + 1900 << "." <<
    timeinfo->tm_mon+1 << "." << timeinfo->tm_mday << " " <<
    timeinfo->tm_hour << ":" << timeinfo->tm_min << ":" <<
    timeinfo->tm_sec << " ";
    switch (tk.priority) {
      case HIGH: cout << "high"; break;
      case MIDDLE: cout << "middle"; break;
      default: cout << "low"; break;
    }
    cout << " " << tk.label << " " << tk.status << " " << tk.text << " " << tk.skill << endl;
  }
}

void activate_task_text (char * task_filename, char * task_record_filename,
                                                         char *text_shablon) {
  string fn = task_filename;
  string fnr = task_record_filename;
  tasks tsk (&fn,&fnr);
  struct task ts = {0};
  tsk.show_tasks_reset();
  while(tsk.show_tasks(&ts) != NULL) {
    if ((ts.label.find(text_shablon) != string::npos) ||
        (ts.status.find(text_shablon) != string::npos) ||
        (ts.text.find(text_shablon) != string::npos) ||
        (ts.skill.find(text_shablon) != string::npos)) {
      tsk.activate_task (&ts.id);
      break;
    }
  }
}

void activate_task_number (char * task_filename, char * task_record_filename,
                                                         char *number) {
  string fn = task_filename;
  string fnr = task_record_filename;
  tasks tsk (&fn,&fnr);
  struct task ts = {0};
  tsk.show_tasks_reset();
  int count = 0;
  while(tsk.show_tasks(&ts) != NULL) {
    if ((atoi(number) - 1) == count) {
      tsk.activate_task (&ts.id);
      break;
    }
    count++;
  }
}

void deactivate_task (char * task_filename, char * task_record_filename) {
  string buff = task_filename;
  string fntr = task_record_filename;
  tasks tsk (&buff,&fntr);
  tsk.deactivate_task();
}

void show_active_task (char * task_filename, char * task_record_filename) {
  string buff = task_filename;
  string fntr = task_record_filename;
  tasks tsk (&buff,&fntr);
  tsk.show_active_task (&buff);
  tsk.show_tasks_reset();
  struct task tk = {0};
  struct tm * timeinfo = localtime(&tk.create_time);
  while(tsk.show_tasks(&tk) != NULL) {
    timeinfo = localtime(&tk.start_time);
    if (tk.id == buff) {
      cout << "From: " << timeinfo->tm_year + 1900 << "." <<
      timeinfo->tm_mon+1 << "." << timeinfo->tm_mday << " " <<
      timeinfo->tm_hour << ":" << timeinfo->tm_min << ":" <<
      timeinfo->tm_sec;
      timeinfo = localtime(&tk.stop_time);
      cout << " to: " << timeinfo->tm_year + 1900 << "." <<
      timeinfo->tm_mon+1 << "." << timeinfo->tm_mday << " " <<
      timeinfo->tm_hour << ":" << timeinfo->tm_min << ":" <<
      timeinfo->tm_sec << " ";
      switch (tk.priority) {
        case HIGH: cout << "high"; break;
        case MIDDLE: cout << "middle"; break;
        default: cout << "low"; break;
      }
      cout << " " << tk.label << " " << tk.status << " " << tk.text << " " << tk.skill << endl;
    }
  }
}

void show_help () {
  cout << endl << "abashin.ru version 0.0.2 alpha" << endl << endl;
  cout << "Activate task: ./abashin.ru.tasks -atts \"text_shablon\""
       << endl << " \"path/task_filename\" \"path/task_record_filename\"" << endl;
  cout << "Activate task: ./abashin.ru.tasks -atn \"number\" \"path/task_filename\""
       << endl << " \"path/task_record_filename\"" << endl;
  cout << "Deactivate task: ./abashin.ru.tasks -dat \"path/task_filename\"" << endl <<
          " \"path/task_record_filename\"" << endl;
  cout << "Show active task: ./abashin.ru.tasks -sat \"path/task_filename\"" << endl <<
          " \"path/task_record_filename\"" << endl;
  cout << "Show all tasks: ./abashin.ru.tasks -st \"path/filename\"" << endl;
  cout << "Add task: ./abashin.ru.tasks -ct \"start_time\" \"stop_time\"" << endl
       << " \"priority\" \"label\" \"text\" \"skill\" \"status\" \"path/filename\"" << endl;
  cout << "Delete task: ./abashin.ru.tasks -dtt \"text shablon\" \"path/filename\"" << endl;
  cout << "Delete task: ./abashin.ru.tasks -dtn \"number\" \"path/filename\"" << endl;
  cout << "Delete all local task: ./abashin.ru.tasks -dlt \"path/filename\"" << endl;
  cout << "Show skills: ./abashin.ru.tasks -ss \"path/filename\"" << endl;
  cout << "Delete skill: ./abashin.ru.tasks -ds \"my category\" \"path/filename\"" << endl;
  cout << "Change the name of the skill: ./abashin.ru.tasks -cns \"old name\" \"new name\"" <<
          endl << " \"path/filename\"" << endl;
  cout << "Delete task skill: ./abashin.ru.tasks -dts \"skill\" \"path/filename\"" << endl;
  cout << "Find the pattern: ./abashin.ru.tasks -ft \"text shablon\" \"path/filename\"" << endl << endl;
}


int main (int argc, char * argv[]) {
  switch (argc) {
    case 3: {
      if (strcmp(argv[1],"-st") == 0) { show_all_tasks (argv[2]); break;}
      if (strcmp(argv[1],"-dlt") == 0) { delete_all_local_tasks (argv[2]); break;}
      if (strcmp(argv[1],"-ss") == 0) { show_all_skills (argv[2]); break; }
      show_help();
      break;
    }
    case 4: {
      if (strcmp(argv[1],"-dat") == 0) { deactivate_task (argv[2], argv[3]); break;}
      if (strcmp(argv[1],"-sat") == 0) { show_active_task (argv[2], argv[3]); break;}
      if (strcmp(argv[1],"-dtt") == 0) { delete_task_t (argv[3], argv[2]); break;}
      if (strcmp(argv[1],"-dtn") == 0) { delete_task_n (argv[3], argv[2]); break;}
      if (strcmp(argv[1],"-cs") == 0) { add_skill (argv[3], argv[2]); break;}
      if (strcmp(argv[1],"-ds") == 0) { delete_skill (argv[3], argv[2]); break;}
      if (strcmp(argv[1],"-dts") == 0) { delete_tasks_skill (argv[3], argv[2]); break;}
      if (strcmp(argv[1],"-ft") == 0) { find_tasks (argv[3], argv[2]); break; }
      show_help();
      break;
    }
    case 5: {
      if (strcmp(argv[1],"-atts") == 0) { activate_task_text (argv[3], argv[4], argv[2]); break;}
      if (strcmp(argv[1],"-atn") == 0) { activate_task_number (argv[3], argv[4], argv[2]); break;}
      if (strcmp(argv[1],"-cns") == 0) { change_skill_name (argv[4], argv[2], argv[3]); break;}
      show_help();
      break;
    }
    case 10: {
      if (strcmp(argv[1],"-ct") == 0) { add_task (argv[9], argv[2], argv[3], argv[4],
                                        argv[5], argv[6], argv[7], argv[8]); break;}
      show_help();
      break;
    }
    default: show_help();
  }
  return 0;
}
